// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias AddStickerToSetCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to add a new sticker to a set created by the bot. Returns True on success.
    /// - Parameters:
    ///     - user_id: User identifier of sticker set owner
    ///     - name: Sticker set name
    ///     - png_sticker: Png image with the sticker, must be up to 512 kilobytes in size, dimensions must not exceed 512px, and either width or height must be exactly 512px. Pass a file_id as a String to send a file that already exists on the Telegram servers, pass an HTTP URL as a String for Telegram to get a file from the Internet, or upload a new one using multipart/form-data. More info on Sending Files »
    ///     - emojis: One or more emoji corresponding to the sticker
    ///     - mask_position: A JSON-serialized object for position where the mask should be placed on faces
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#addstickertoset>
    @discardableResult
    public func addStickerToSetSync(
            userId: Int64,
            name: String,
            pngSticker: FileInfo,
            emojis: String,
            maskPosition: MaskPosition? = nil,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("addStickerToSet", defaultParameters["addStickerToSet"], parameters, [
            "user_id": userId,
            "name": name,
            "png_sticker": pngSticker,
            "emojis": emojis,
            "mask_position": maskPosition])
    }

    /// Use this method to add a new sticker to a set created by the bot. Returns True on success.
    /// - Parameters:
    ///     - user_id: User identifier of sticker set owner
    ///     - name: Sticker set name
    ///     - png_sticker: Png image with the sticker, must be up to 512 kilobytes in size, dimensions must not exceed 512px, and either width or height must be exactly 512px. Pass a file_id as a String to send a file that already exists on the Telegram servers, pass an HTTP URL as a String for Telegram to get a file from the Internet, or upload a new one using multipart/form-data. More info on Sending Files »
    ///     - emojis: One or more emoji corresponding to the sticker
    ///     - mask_position: A JSON-serialized object for position where the mask should be placed on faces
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#addstickertoset>
    public func addStickerToSetAsync(
            userId: Int64,
            name: String,
            pngSticker: FileInfo,
            emojis: String,
            maskPosition: MaskPosition? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: AddStickerToSetCompletion? = nil) {
        return requestAsync("addStickerToSet", defaultParameters["addStickerToSet"], parameters, [
            "user_id": userId,
            "name": name,
            "png_sticker": pngSticker,
            "emojis": emojis,
            "mask_position": maskPosition],
            queue: queue, completion: completion)
    }
}

