// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias DeleteStickerFromSetCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to delete a sticker from a set created by the bot. Returns True on success.
    /// - Parameters:
    ///     - sticker: File identifier of the sticker
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletestickerfromset>
    @discardableResult
    public func deleteStickerFromSetSync(
            sticker: String,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("deleteStickerFromSet", defaultParameters["deleteStickerFromSet"], parameters, [
            "sticker": sticker])
    }

    /// Use this method to delete a sticker from a set created by the bot. Returns True on success.
    /// - Parameters:
    ///     - sticker: File identifier of the sticker
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletestickerfromset>
    public func deleteStickerFromSetAsync(
            sticker: String,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: DeleteStickerFromSetCompletion? = nil) {
        return requestAsync("deleteStickerFromSet", defaultParameters["deleteStickerFromSet"], parameters, [
            "sticker": sticker],
            queue: queue, completion: completion)
    }
}

