// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias GetGameHighScoresCompletion = (_ result: [GameHighScore]?, _ error: DataTaskError?) -> ()

    /// Use this method to get data for high score tables. Will return the score of the specified user and several of his neighbors in a game. On success, returns an Array of GameHighScore objects.
    /// This method will currently return scores for the target user, plus two of his closest neighbors on each side. Will also return the top three users if the user and his neighbors are not among them. Please note that this behavior is subject to change.
    /// - Parameters:
    ///     - user_id: Target user id
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    /// - Returns: [GameHighScore] on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getgamehighscores>
    @discardableResult
    public func getGameHighScoresSync(
            userId: Int64,
            chatId: Int64? = nil,
            messageId: Int? = nil,
            inlineMessageId: String? = nil,
            _ parameters: [String: Any?] = [:]) -> [GameHighScore]? {
        return requestSync("getGameHighScores", defaultParameters["getGameHighScores"], parameters, [
            "user_id": userId,
            "chat_id": chatId,
            "message_id": messageId,
            "inline_message_id": inlineMessageId])
    }

    /// Use this method to get data for high score tables. Will return the score of the specified user and several of his neighbors in a game. On success, returns an Array of GameHighScore objects.
    /// This method will currently return scores for the target user, plus two of his closest neighbors on each side. Will also return the top three users if the user and his neighbors are not among them. Please note that this behavior is subject to change.
    /// - Parameters:
    ///     - user_id: Target user id
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    /// - Returns: [GameHighScore] on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getgamehighscores>
    public func getGameHighScoresAsync(
            userId: Int64,
            chatId: Int64? = nil,
            messageId: Int? = nil,
            inlineMessageId: String? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: GetGameHighScoresCompletion? = nil) {
        return requestAsync("getGameHighScores", defaultParameters["getGameHighScores"], parameters, [
            "user_id": userId,
            "chat_id": chatId,
            "message_id": messageId,
            "inline_message_id": inlineMessageId],
            queue: queue, completion: completion)
    }
}

