// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias KickChatMemberCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to kick a user from a group, a supergroup or a channel. In the case of supergroups and channels, the user will not be able to return to the group on their own using invite links, etc., unless unbanned first. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group. Otherwise members may only be removed by the group's creator or by the member that added them.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target group or username of the target supergroup or channel (in the format @channelusername)
    ///     - user_id: Unique identifier of the target user
    ///     - until_date: Date when the user will be unbanned, unix time. If user is banned for more than 366 days or less than 30 seconds from the current time they are considered to be banned forever
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#kickchatmember>
    @discardableResult
    public func kickChatMemberSync(
            chatId: ChatId,
            userId: Int64,
            untilDate: Int? = nil,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("kickChatMember", defaultParameters["kickChatMember"], parameters, [
            "chat_id": chatId,
            "user_id": userId,
            "until_date": untilDate])
    }

    /// Use this method to kick a user from a group, a supergroup or a channel. In the case of supergroups and channels, the user will not be able to return to the group on their own using invite links, etc., unless unbanned first. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group. Otherwise members may only be removed by the group's creator or by the member that added them.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target group or username of the target supergroup or channel (in the format @channelusername)
    ///     - user_id: Unique identifier of the target user
    ///     - until_date: Date when the user will be unbanned, unix time. If user is banned for more than 366 days or less than 30 seconds from the current time they are considered to be banned forever
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#kickchatmember>
    public func kickChatMemberAsync(
            chatId: ChatId,
            userId: Int64,
            untilDate: Int? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: KickChatMemberCompletion? = nil) {
        return requestAsync("kickChatMember", defaultParameters["kickChatMember"], parameters, [
            "chat_id": chatId,
            "user_id": userId,
            "until_date": untilDate],
            queue: queue, completion: completion)
    }
}

