// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias SendVideoCompletion = (_ result: Message?, _ error: DataTaskError?) -> ()

    /// Use this method to send video files, Telegram clients support mp4 videos (other formats may be sent as Document). On success, the sent Message is returned. Bots can currently send video files of up to 50 MB in size, this limit may be changed in the future.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - video: Video to send. Pass a file_id as String to send a video that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get a video from the Internet, or upload a new video using multipart/form-data. More info on Sending Files »
    ///     - duration: Duration of sent video in seconds
    ///     - width: Video width
    ///     - height: Video height
    ///     - caption: Video caption (may also be used when resending videos by file_id), 0-200 characters
    ///     - parse_mode: Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption.
    ///     - supports_streaming: Pass True, if the uploaded video is suitable for streaming
    ///     - disable_notification: Sends the message silently. Users will receive a notification with no sound.
    ///     - reply_to_message_id: If the message is a reply, ID of the original message
    ///     - reply_markup: Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.
    /// - Returns: Message on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#sendvideo>
    @discardableResult
    public func sendVideoSync(
            chatId: ChatId,
            video: FileInfo,
            duration: Int? = nil,
            width: Int? = nil,
            height: Int? = nil,
            caption: String? = nil,
            parseMode: ParseMode? = nil,
            supportsStreaming: Bool? = nil,
            disableNotification: Bool? = nil,
            replyToMessageId: Int? = nil,
            replyMarkup: ReplyMarkup? = nil,
            _ parameters: [String: Any?] = [:]) -> Message? {
        return requestSync("sendVideo", defaultParameters["sendVideo"], parameters, [
            "chat_id": chatId,
            "video": video,
            "duration": duration,
            "width": width,
            "height": height,
            "caption": caption,
            "parse_mode": parseMode?.rawValue,
            "supports_streaming": supportsStreaming,
            "disable_notification": disableNotification,
            "reply_to_message_id": replyToMessageId,
            "reply_markup": replyMarkup])
    }

    /// Use this method to send video files, Telegram clients support mp4 videos (other formats may be sent as Document). On success, the sent Message is returned. Bots can currently send video files of up to 50 MB in size, this limit may be changed in the future.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - video: Video to send. Pass a file_id as String to send a video that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get a video from the Internet, or upload a new video using multipart/form-data. More info on Sending Files »
    ///     - duration: Duration of sent video in seconds
    ///     - width: Video width
    ///     - height: Video height
    ///     - caption: Video caption (may also be used when resending videos by file_id), 0-200 characters
    ///     - parse_mode: Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption.
    ///     - supports_streaming: Pass True, if the uploaded video is suitable for streaming
    ///     - disable_notification: Sends the message silently. Users will receive a notification with no sound.
    ///     - reply_to_message_id: If the message is a reply, ID of the original message
    ///     - reply_markup: Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.
    /// - Returns: Message on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#sendvideo>
    public func sendVideoAsync(
            chatId: ChatId,
            video: FileInfo,
            duration: Int? = nil,
            width: Int? = nil,
            height: Int? = nil,
            caption: String? = nil,
            parseMode: ParseMode? = nil,
            supportsStreaming: Bool? = nil,
            disableNotification: Bool? = nil,
            replyToMessageId: Int? = nil,
            replyMarkup: ReplyMarkup? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: SendVideoCompletion? = nil) {
        return requestAsync("sendVideo", defaultParameters["sendVideo"], parameters, [
            "chat_id": chatId,
            "video": video,
            "duration": duration,
            "width": width,
            "height": height,
            "caption": caption,
            "parse_mode": parseMode?.rawValue,
            "supports_streaming": supportsStreaming,
            "disable_notification": disableNotification,
            "reply_to_message_id": replyToMessageId,
            "reply_markup": replyMarkup],
            queue: queue, completion: completion)
    }
}

