// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias SetChatStickerSetCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to set a new group sticker set for a supergroup. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Use the field can_set_sticker_set optionally returned in getChat requests to check if the bot can use this method. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername)
    ///     - sticker_set_name: Name of the sticker set to be set as the group sticker set
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setchatstickerset>
    @discardableResult
    public func setChatStickerSetSync(
            chatId: ChatId,
            stickerSetName: String,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("setChatStickerSet", defaultParameters["setChatStickerSet"], parameters, [
            "chat_id": chatId,
            "sticker_set_name": stickerSetName])
    }

    /// Use this method to set a new group sticker set for a supergroup. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Use the field can_set_sticker_set optionally returned in getChat requests to check if the bot can use this method. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername)
    ///     - sticker_set_name: Name of the sticker set to be set as the group sticker set
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setchatstickerset>
    public func setChatStickerSetAsync(
            chatId: ChatId,
            stickerSetName: String,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: SetChatStickerSetCompletion? = nil) {
        return requestAsync("setChatStickerSet", defaultParameters["setChatStickerSet"], parameters, [
            "chat_id": chatId,
            "sticker_set_name": stickerSetName],
            queue: queue, completion: completion)
    }
}

