// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation


/// Upon receiving a message with this object, Telegram clients will display a reply interface to the user (act as if the user has selected the bot‘s message and tapped ’Reply'). This can be extremely useful if you want to create user-friendly step-by-step interfaces without having to sacrifice privacy mode.
///
/// - SeeAlso: <https://core.telegram.org/bots/api#forcereply>

public struct ForceReply: JsonConvertible, InternalJsonConvertible {
    /// Original JSON for fields not yet added to Swift structures.
    public var json: Any {
        get {
            return internalJson.object
        }
        set {
            internalJson = JSON(newValue)
        }
    }
    internal var internalJson: JSON

    /// Shows reply interface to the user, as if they manually selected the bot‘s message and tapped ’Reply'
    public var forceReply: Bool {
        get { return internalJson["force_reply"].boolValue }
        set { internalJson["force_reply"].boolValue = newValue }
    }

    /// Optional. Use this parameter if you want to force reply from specific users only. Targets: 1) users that are @mentioned in the text of the Message object; 2) if the bot's message is a reply (has reply_to_message_id), sender of the original message.
    public var selective: Bool? {
        get { return internalJson["selective"].bool }
        set { internalJson["selective"].bool = newValue }
    }

    internal init(internalJson: JSON = ["force_reply": true]) {
        self.internalJson = internalJson
    }
    public init(json: Any) {
        self.internalJson = JSON(json)
    }
    public init(data: Data) {
        self.internalJson = JSON(data: data)
    }
}
