// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation


/// Represents a video to be sent.
///
/// - SeeAlso: <https://core.telegram.org/bots/api#inputmediavideo>

public struct InputMediaVideo: JsonConvertible, InternalJsonConvertible {
    /// Original JSON for fields not yet added to Swift structures.
    public var json: Any {
        get {
            return internalJson.object
        }
        set {
            internalJson = JSON(newValue)
        }
    }
    internal var internalJson: JSON

    /// Type of the result, must be video
    public var typeString: String {
        get { return internalJson["type"].stringValue }
        set { internalJson["type"].stringValue = newValue }
    }

    /// File to send. Pass a file_id to send a file that exists on the Telegram servers (recommended), pass an HTTP URL for Telegram to get a file from the Internet, or pass "attach://<file_attach_name>" to upload a new one using multipart/form-data under <file_attach_name> name. More info on Sending Files »
    public var media: String {
        get { return internalJson["media"].stringValue }
        set { internalJson["media"].stringValue = newValue }
    }

    /// Optional. Caption of the video to be sent, 0-200 characters
    public var caption: String? {
        get { return internalJson["caption"].string }
        set { internalJson["caption"].string = newValue }
    }

    /// Optional. Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption.
    public var parseModeString: String? {
        get { return internalJson["parse_mode"].string }
        set { internalJson["parse_mode"].string = newValue }
    }

    /// Optional. Video width
    public var width: Int? {
        get { return internalJson["width"].int }
        set { internalJson["width"].int = newValue }
    }

    /// Optional. Video height
    public var height: Int? {
        get { return internalJson["height"].int }
        set { internalJson["height"].int = newValue }
    }

    /// Optional. Video duration
    public var duration: Int? {
        get { return internalJson["duration"].int }
        set { internalJson["duration"].int = newValue }
    }

    /// Optional. Pass True, if the uploaded video is suitable for streaming
    public var supportsStreaming: Bool? {
        get { return internalJson["supports_streaming"].bool }
        set { internalJson["supports_streaming"].bool = newValue }
    }

    internal init(internalJson: JSON = [:]) {
        self.internalJson = internalJson
    }
    public init(json: Any) {
        self.internalJson = JSON(json)
    }
    public init(data: Data) {
        self.internalJson = JSON(data: data)
    }
}
