// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation


/// Represents the content of a text message to be sent as the result of an inline query.
///
/// - SeeAlso: <https://core.telegram.org/bots/api#inputtextmessagecontent>

public struct InputTextMessageContent: JsonConvertible, InternalJsonConvertible {
    /// Original JSON for fields not yet added to Swift structures.
    public var json: Any {
        get {
            return internalJson.object
        }
        set {
            internalJson = JSON(newValue)
        }
    }
    internal var internalJson: JSON

    /// Text of the message to be sent, 1-4096 characters
    public var messageText: String {
        get { return internalJson["message_text"].stringValue }
        set { internalJson["message_text"].stringValue = newValue }
    }

    /// Optional. Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in your bot's message.
    public var parseModeString: String? {
        get { return internalJson["parse_mode"].string }
        set { internalJson["parse_mode"].string = newValue }
    }

    /// Optional. Disables link previews for links in the sent message
    public var disableWebPagePreview: Bool? {
        get { return internalJson["disable_web_page_preview"].bool }
        set { internalJson["disable_web_page_preview"].bool = newValue }
    }

    internal init(internalJson: JSON = [:]) {
        self.internalJson = internalJson
    }
    public init(json: Any) {
        self.internalJson = JSON(json)
    }
    public init(data: Data) {
        self.internalJson = JSON(data: data)
    }
}
