// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation


/// This object describes the position on faces where a mask should be placed by default.
///
/// - SeeAlso: <https://core.telegram.org/bots/api#maskposition>

public struct MaskPosition: JsonConvertible, InternalJsonConvertible {
    /// Original JSON for fields not yet added to Swift structures.
    public var json: Any {
        get {
            return internalJson.object
        }
        set {
            internalJson = JSON(newValue)
        }
    }
    internal var internalJson: JSON

    /// The part of the face relative to which the mask should be placed. One of “forehead”, “eyes”, “mouth”, or “chin”.
    public var point: String {
        get { return internalJson["point"].stringValue }
        set { internalJson["point"].stringValue = newValue }
    }

    /// Shift by X-axis measured in widths of the mask scaled to the face size, from left to right. For example, choosing -1.0 will place mask just to the left of the default mask position.
    public var xShift: Float {
        get { return internalJson["x_shift"].floatValue }
        set { internalJson["x_shift"].floatValue = newValue }
    }

    /// Shift by Y-axis measured in heights of the mask scaled to the face size, from top to bottom. For example, 1.0 will place the mask just below the default mask position.
    public var yShift: Float {
        get { return internalJson["y_shift"].floatValue }
        set { internalJson["y_shift"].floatValue = newValue }
    }

    /// Mask scaling coefficient. For example, 2.0 means double size.
    public var scale: Float {
        get { return internalJson["scale"].floatValue }
        set { internalJson["scale"].floatValue = newValue }
    }

    internal init(internalJson: JSON = [:]) {
        self.internalJson = internalJson
    }
    public init(json: Any) {
        self.internalJson = JSON(json)
    }
    public init(data: Data) {
        self.internalJson = JSON(data: data)
    }
}
