// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation


/// This object represents a message.
///
/// - SeeAlso: <https://core.telegram.org/bots/api#message>

public struct Message: JsonConvertible, InternalJsonConvertible {
    /// Original JSON for fields not yet added to Swift structures.
    public var json: Any {
        get {
            return internalJson.object
        }
        set {
            internalJson = JSON(newValue)
        }
    }
    internal var internalJson: JSON

    /// Unique message identifier inside this chat
    public var messageId: Int {
        get { return internalJson["message_id"].intValue }
        set { internalJson["message_id"].intValue = newValue }
    }

    /// Optional. Sender, empty for messages sent to channels
    public var from: User? {
        get {
            let value = internalJson["from"]
            return value.isNullOrUnknown ? nil : User(internalJson: value)
        }
        set {
            internalJson["from"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Date the message was sent in Unix time
    public var date: Date {
        get { return Date(timeIntervalSince1970: internalJson["date"].doubleValue) }
        set { internalJson["date"].double = newValue.timeIntervalSince1970 }
    }

    /// Conversation the message belongs to
    public var chat: Chat {
        get { return Chat(internalJson: internalJson["chat"]) }
        set { internalJson["chat"] = JSON(newValue.json) }
    }

    /// Optional. For forwarded messages, sender of the original message
    public var forwardFrom: User? {
        get {
            let value = internalJson["forward_from"]
            return value.isNullOrUnknown ? nil : User(internalJson: value)
        }
        set {
            internalJson["forward_from"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. For messages forwarded from channels, information about the original channel
    public var forwardFromChat: Chat? {
        get {
            let value = internalJson["forward_from_chat"]
            return value.isNullOrUnknown ? nil : Chat(internalJson: value)
        }
        set {
            internalJson["forward_from_chat"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. For messages forwarded from channels, identifier of the original message in the channel
    public var forwardFromMessageId: Int? {
        get { return internalJson["forward_from_message_id"].int }
        set { internalJson["forward_from_message_id"].int = newValue }
    }

    /// Optional. For messages forwarded from channels, signature of the post author if present
    public var forwardSignature: String? {
        get { return internalJson["forward_signature"].string }
        set { internalJson["forward_signature"].string = newValue }
    }

    /// Optional. For forwarded messages, date the original message was sent in Unix time
    public var forwardDate: Date? {
        get {
            guard let date = internalJson["forward_date"].double else { return nil }
            return Date(timeIntervalSince1970: date)
        }
        set {
            internalJson["forward_date"].double = newValue?.timeIntervalSince1970
        }
    }

    /// Optional. For replies, the original message. Note that the Message object in this field will not contain further reply_to_message fields even if it itself is a reply.
    public var replyToMessage: Message? {
        get {
            let value = internalJson["reply_to_message"]
            return value.isNullOrUnknown ? nil : Message(internalJson: value)
        }
        set {
            internalJson["reply_to_message"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Date the message was last edited in Unix time
    public var editDate: Date? {
        get {
            guard let date = internalJson["edit_date"].double else { return nil }
            return Date(timeIntervalSince1970: date)
        }
        set {
            internalJson["edit_date"].double = newValue?.timeIntervalSince1970
        }
    }

    /// Optional. The unique identifier of a media message group this message belongs to
    public var mediaGroupId: String? {
        get { return internalJson["media_group_id"].string }
        set { internalJson["media_group_id"].string = newValue }
    }

    /// Optional. Signature of the post author for messages in channels
    public var authorSignature: String? {
        get { return internalJson["author_signature"].string }
        set { internalJson["author_signature"].string = newValue }
    }

    /// Optional. For text messages, the actual UTF-8 text of the message, 0-4096 characters.
    public var text: String? {
        get { return internalJson["text"].string }
        set { internalJson["text"].string = newValue }
    }

    /// Optional. For text messages, special entities like usernames, URLs, bot commands, etc. that appear in the text
    public var entities: [MessageEntity] {
        get { return internalJson["entities"].customArrayValue() }
        set { internalJson["entities"] = newValue.isEmpty ? JSON.null : JSON.initFrom(newValue) }
    }

    /// Optional. For messages with a caption, special entities like usernames, URLs, bot commands, etc. that appear in the caption
    public var captionEntities: [MessageEntity] {
        get { return internalJson["caption_entities"].customArrayValue() }
        set { internalJson["caption_entities"] = newValue.isEmpty ? JSON.null : JSON.initFrom(newValue) }
    }

    /// Optional. Message is an audio file, information about the file
    public var audio: Audio? {
        get {
            let value = internalJson["audio"]
            return value.isNullOrUnknown ? nil : Audio(internalJson: value)
        }
        set {
            internalJson["audio"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a general file, information about the file
    public var document: Document? {
        get {
            let value = internalJson["document"]
            return value.isNullOrUnknown ? nil : Document(internalJson: value)
        }
        set {
            internalJson["document"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a game, information about the game. More about games »
    public var game: Game? {
        get {
            let value = internalJson["game"]
            return value.isNullOrUnknown ? nil : Game(internalJson: value)
        }
        set {
            internalJson["game"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a photo, available sizes of the photo
    public var photo: [PhotoSize] {
        get { return internalJson["photo"].customArrayValue() }
        set { internalJson["photo"] = newValue.isEmpty ? JSON.null : JSON.initFrom(newValue) }
    }

    /// Optional. Message is a sticker, information about the sticker
    public var sticker: Sticker? {
        get {
            let value = internalJson["sticker"]
            return value.isNullOrUnknown ? nil : Sticker(internalJson: value)
        }
        set {
            internalJson["sticker"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a video, information about the video
    public var video: Video? {
        get {
            let value = internalJson["video"]
            return value.isNullOrUnknown ? nil : Video(internalJson: value)
        }
        set {
            internalJson["video"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a voice message, information about the file
    public var voice: Voice? {
        get {
            let value = internalJson["voice"]
            return value.isNullOrUnknown ? nil : Voice(internalJson: value)
        }
        set {
            internalJson["voice"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a video note, information about the video message
    public var videoNote: VideoNote? {
        get {
            let value = internalJson["video_note"]
            return value.isNullOrUnknown ? nil : VideoNote(internalJson: value)
        }
        set {
            internalJson["video_note"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Caption for the audio, document, photo, video or voice, 0-200 characters
    public var caption: String? {
        get { return internalJson["caption"].string }
        set { internalJson["caption"].string = newValue }
    }

    /// Optional. Message is a shared contact, information about the contact
    public var contact: Contact? {
        get {
            let value = internalJson["contact"]
            return value.isNullOrUnknown ? nil : Contact(internalJson: value)
        }
        set {
            internalJson["contact"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a shared location, information about the location
    public var location: Location? {
        get {
            let value = internalJson["location"]
            return value.isNullOrUnknown ? nil : Location(internalJson: value)
        }
        set {
            internalJson["location"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a venue, information about the venue
    public var venue: Venue? {
        get {
            let value = internalJson["venue"]
            return value.isNullOrUnknown ? nil : Venue(internalJson: value)
        }
        set {
            internalJson["venue"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. New members that were added to the group or supergroup and information about them (the bot itself may be one of these members)
    public var newChatMembers: [User] {
        get { return internalJson["new_chat_members"].customArrayValue() }
        set { internalJson["new_chat_members"] = newValue.isEmpty ? JSON.null : JSON.initFrom(newValue) }
    }

    /// Optional. A member was removed from the group, information about them (this member may be the bot itself)
    public var leftChatMember: User? {
        get {
            let value = internalJson["left_chat_member"]
            return value.isNullOrUnknown ? nil : User(internalJson: value)
        }
        set {
            internalJson["left_chat_member"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. A chat title was changed to this value
    public var newChatTitle: String? {
        get { return internalJson["new_chat_title"].string }
        set { internalJson["new_chat_title"].string = newValue }
    }

    /// Optional. A chat photo was change to this value
    public var newChatPhoto: [PhotoSize] {
        get { return internalJson["new_chat_photo"].customArrayValue() }
        set { internalJson["new_chat_photo"] = newValue.isEmpty ? JSON.null : JSON.initFrom(newValue) }
    }

    /// Optional. Service message: the chat photo was deleted
    public var deleteChatPhoto: Bool? {
        get { return internalJson["delete_chat_photo"].bool }
        set { internalJson["delete_chat_photo"].bool = newValue }
    }

    /// Optional. Service message: the group has been created
    public var groupChatCreated: Bool? {
        get { return internalJson["group_chat_created"].bool }
        set { internalJson["group_chat_created"].bool = newValue }
    }

    /// Optional. Service message: the supergroup has been created. This field can‘t be received in a message coming through updates, because bot can’t be a member of a supergroup when it is created. It can only be found in reply_to_message if someone replies to a very first message in a directly created supergroup.
    public var supergroupChatCreated: Bool? {
        get { return internalJson["supergroup_chat_created"].bool }
        set { internalJson["supergroup_chat_created"].bool = newValue }
    }

    /// Optional. Service message: the channel has been created. This field can‘t be received in a message coming through updates, because bot can’t be a member of a channel when it is created. It can only be found in reply_to_message if someone replies to a very first message in a channel.
    public var channelChatCreated: Bool? {
        get { return internalJson["channel_chat_created"].bool }
        set { internalJson["channel_chat_created"].bool = newValue }
    }

    /// Optional. The group has been migrated to a supergroup with the specified identifier. This number may be greater than 32 bits and some programming languages may have difficulty/silent defects in interpreting it. But it is smaller than 52 bits, so a signed 64 bit integer or double-precision float type are safe for storing this identifier.
    public var migrateToChatId: Int64? {
        get { return internalJson["migrate_to_chat_id"].int64 }
        set { internalJson["migrate_to_chat_id"].int64 = newValue }
    }

    /// Optional. The supergroup has been migrated from a group with the specified identifier. This number may be greater than 32 bits and some programming languages may have difficulty/silent defects in interpreting it. But it is smaller than 52 bits, so a signed 64 bit integer or double-precision float type are safe for storing this identifier.
    public var migrateFromChatId: Int64? {
        get { return internalJson["migrate_from_chat_id"].int64 }
        set { internalJson["migrate_from_chat_id"].int64 = newValue }
    }

    /// Optional. Specified message was pinned. Note that the Message object in this field will not contain further reply_to_message fields even if it is itself a reply.
    public var pinnedMessage: Message? {
        get {
            let value = internalJson["pinned_message"]
            return value.isNullOrUnknown ? nil : Message(internalJson: value)
        }
        set {
            internalJson["pinned_message"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is an invoice for a payment, information about the invoice. More about payments »
    public var invoice: Invoice? {
        get {
            let value = internalJson["invoice"]
            return value.isNullOrUnknown ? nil : Invoice(internalJson: value)
        }
        set {
            internalJson["invoice"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. Message is a service message about a successful payment, information about the payment. More about payments »
    public var successfulPayment: SuccessfulPayment? {
        get {
            let value = internalJson["successful_payment"]
            return value.isNullOrUnknown ? nil : SuccessfulPayment(internalJson: value)
        }
        set {
            internalJson["successful_payment"] = newValue?.internalJson ?? JSON.null
        }
    }

    /// Optional. The domain name of the website on which the user has logged in. More about Telegram Login »
    public var connectedWebsite: String? {
        get { return internalJson["connected_website"].string }
        set { internalJson["connected_website"].string = newValue }
    }

    internal init(internalJson: JSON = [:]) {
        self.internalJson = internalJson
    }
    public init(json: Any) {
        self.internalJson = JSON(json)
    }
    public init(data: Data) {
        self.internalJson = JSON(data: data)
    }
}
